//---------------------------------------------------------------------------
#include <vcl.h>
#include <stdlib.h>
#pragma hdrstop

#include "MainForm.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"

#define COLCOUNT 4

TForm1 *Form1;
int FormLeft, FormTop, FormWidth, FormHeight; 
//---------------------------------------------------------------------------
__fastcall TForm1::TForm1(TComponent* Owner)
  : TForm(Owner)
{
  data = new TStringList();
  curdata = new TStringList();
  curindex = 9999;
  bmp = new Graphics::TBitmap();
  bmp->Canvas->Font->Assign(Font);
  ClearBmp();
  randomize();
}
//---------------------------------------------------------------------------
void TForm1::Open(AnsiString FileName)
{
  data->Clear();
  data->LoadFromFile(FileName);
  curdata->Clear();
  curindex = 9999;
}
//---------------------------------------------------------------------------
bool TForm1::Select()
{
  int count = data->Count;
  ClearBmp();
  if(count == 0){ return false; }
  int x = random(count);
  curdata->CommaText = data->Strings[x];
  data->Delete(x);
  curindex = 0;
  return true;
}
//---------------------------------------------------------------------------
bool TForm1::ShowNext()
{
  if(curindex >= COLCOUNT || curindex >= curdata->Count){
    if(!Select()){ return false; }
  }
  AnsiString str = curdata->Strings[curindex];
  int yunit = bmp->Height / 20;
  int y = yunit;
  int x = 0;
  int size = yunit;
  int color = 0;
  switch(curindex){
    case 0:
      y = yunit * 1;
      size = yunit;
      bmp->Canvas->Font->Size = size;
      x = (bmp->Width / 4) - bmp->Canvas->TextWidth(str);
      Timer->Interval = 100;
      break;
    case 1:
      y = yunit * 3;
      size = yunit * 3 / 2;
      Timer->Interval = 100;
      break;
    case 2:
      y = yunit * 6;
      size = yunit * 3 / 2;
      Timer->Interval = 100;
      break;
    case 3:
      y = yunit * 12;
      size = yunit * 2;
      color = 0x0000ff;
      Timer->Interval = 250;
      break;
  }
  bmp->Canvas->Font->Size = size;
  if(x == 0){ x = (bmp->Width - bmp->Canvas->TextWidth(str))/ 2; }
  curindex++;
  act = TWordAction(str, x, y, size, color, bmp, WA_FADEIN);
  Timer->Enabled = true;
  return true;
}
//---------------------------------------------------------------------------
void __fastcall TForm1::TimerTimer(TObject *Sender)
{
  Timer->Enabled = false;
  if(act.Next()){
    Form1->Canvas->Draw(0, 0, bmp);
    Timer->Enabled = true;
  }
}
//---------------------------------------------------------------------------
void TForm1::ClearBmp()
{
  bmp->Width = ClientWidth;
  bmp->Height = ClientHeight;
  bmp->Canvas->Pen->Color = clWhite;
  bmp->Canvas->Brush->Color = clWhite;
  TRect r;
  r.Left = 0; r.Top = 0;
  r.Right = bmp->Width; r.Bottom = bmp->Height;
  bmp->Canvas->FillRect(r);

  bmp->Canvas->Pen->Color = clPurple;
  for(int i=0; i<20; i++){
    int x = bmp->Width * (19-i) / 20;
    int y = bmp->Height * i / 20;
    bmp->Canvas->MoveTo(x, bmp->Height);
    bmp->Canvas->LineTo(bmp->Width, y);
  }
  act.enable = false;
  Timer->Enabled = false;
}
//---------------------------------------------------------------------------
void __fastcall TForm1::FormShow(TObject *Sender)
{
  if(FileExists("data.csv")){
    Open("data.csv");
  }
}
//---------------------------------------------------------------------------
void __fastcall TForm1::FormKeyDown(TObject *Sender, WORD &Key,
      TShiftState Shift)
{
  if(Shift.Contains(ssCtrl)){
    if(Key == 'O'){
      mnOpenClick(this);
      Key = '\0';
    }
  }else if(Shift.Contains(ssAlt)){
    if(Key == VK_RETURN){
      mnFullScreenClick(this);
      Key = '\0';
    }
  }else if(Key == VK_RETURN || Key == ' '){
    ShowNext();
    Key = '\0';
  }else if(Key == VK_ESCAPE){
    mnShowMenuClick(this);
    Key = '\0';
  }
}
//---------------------------------------------------------------------------
void __fastcall TForm1::FormResize(TObject *Sender)
{
  if(bmp) {
    bmp->Width = ClientWidth;
    bmp->Height = ClientHeight;
    if(curindex >= COLCOUNT){
      ClearBmp();
    }
    Canvas->Draw(0, 0, bmp);
  }
}
//---------------------------------------------------------------------------
void __fastcall TForm1::mnOpenClick(TObject *Sender)
{
  if(dlgOpen->Execute()){
    Open(dlgOpen->FileName);
  }
}
//---------------------------------------------------------------------------
void __fastcall TForm1::mnSelectClick(TObject *Sender)
{
  ShowNext();
}
//---------------------------------------------------------------------------
void __fastcall TForm1::mnExitClick(TObject *Sender)
{
  Close();  
}
//---------------------------------------------------------------------------
void __fastcall TForm1::mnShowMenuClick(TObject *Sender)
{
  if(mnShowMenu->Checked){
    mnShowMenu->Checked = false;
    Menu = NULL;
  }else{
    mnShowMenu->Checked = true;
    Menu = MainMenu;
  }
}
//---------------------------------------------------------------------------
void __fastcall TForm1::mnFullScreenClick(TObject *Sender)
{
  if(mnFullScreen->Checked){
    mnFullScreen->Checked = false;
    BorderStyle = bsSizeable;
    Width = FormWidth; Height = FormHeight;
    Left = FormLeft;   Top = FormTop;
  }else{
    mnFullScreen->Checked = true;
    FormLeft = Left;   FormTop = Top;
    FormWidth = Width; FormHeight = Height;
    BorderStyle = bsNone;
    Left = 0; Top = 0;
    Width = Screen->Width;
    Height = Screen->Height;
  }
}
//---------------------------------------------------------------------------
void __fastcall TForm1::mnAboutClick(TObject *Sender)
{
  Application->MessageBox(
    "ȈՒIvO\n\tby \n\n      2003/10/17",
    "ȈՒIvO", 0);  
}
//---------------------------------------------------------------------------
