//---------------------------------------------------------------------------

#ifndef MainFormH
#define MainFormH
//---------------------------------------------------------------------------
#include <Classes.hpp>
#include <Controls.hpp>
#include <StdCtrls.hpp>
#include <Forms.hpp>
#include <Menus.hpp>
#include <Dialogs.hpp>
#include <ExtCtrls.hpp>
//---------------------------------------------------------------------------
#define WA_FADEIN 0
class TWordAction
{
public:
  AnsiString str;
  int progress;
  int x, y, size;
  int color;
  Graphics::TBitmap *bmp;
  int type;
  bool enable;

  TWordAction() : enable(false) {}
  TWordAction(AnsiString st, int xx, int yy, int sz,
              int cl, Graphics::TBitmap *bm, int tp)
    : str(st), progress(0), x(xx), y(yy), size(sz),
      color(cl), bmp(bm), type(tp), enable(true) {}

  bool Next() {
    if(!enable || progress >= 10){
      enable = false;
      return false;
    }
    progress++;
    int r = 0xff - ((color & 0xff0000) >> 16);
    int g = 0xff - ((color & 0x00ff00) >> 8);
    int b = 0xff - (color & 0x0000ff);
    TColor c = (TColor)((0xff - b * progress / 10) << 16 |
      (0xff - g * progress / 10) << 8 | (0xff - r * progress / 10));
    bmp->Canvas->Font->Color = c;
    bmp->Canvas->TextOut(x, y, str);
    return true;
  }
};
//---------------------------------------------------------------------------
class TForm1 : public TForm
{
__published:	// IDE Ǘ̃R|[lg
  TMainMenu *MainMenu;
  TMenuItem *mnFile;
  TMenuItem *mnView;
  TMenuItem *mnHelp;
  TMenuItem *mnAbout;
  TMenuItem *mnShowMenu;
  TMenuItem *mnFullScreen;
  TMenuItem *mnOpen;
  TMenuItem *N2;
  TMenuItem *mnExit;
  TMenuItem *N1;
  TMenuItem *mnSelect;
  TOpenDialog *dlgOpen;
  TTimer *Timer;
  void __fastcall mnExitClick(TObject *Sender);
  void __fastcall mnShowMenuClick(TObject *Sender);
  void __fastcall FormKeyDown(TObject *Sender, WORD &Key,
          TShiftState Shift);
  void __fastcall mnFullScreenClick(TObject *Sender);
  void __fastcall mnAboutClick(TObject *Sender);
  void __fastcall mnOpenClick(TObject *Sender);
  void __fastcall mnSelectClick(TObject *Sender);
  void __fastcall FormShow(TObject *Sender);
  void __fastcall FormResize(TObject *Sender);
  void __fastcall TimerTimer(TObject *Sender);
private:	// [U[錾
public:		// [U[錾
  __fastcall TForm1(TComponent* Owner);
  void Open(AnsiString FileName);
  bool Select();
  bool ShowNext();
  void ClearBmp();
  TStringList *data;
  TStringList *curdata;
  int curindex;
  int progress;
  Graphics::TBitmap *bmp;
  TWordAction act;
};
//---------------------------------------------------------------------------
extern PACKAGE TForm1 *Form1;
//---------------------------------------------------------------------------
#endif
